HOME must be set before calling git-init when creating test repositories
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
44138559
JS
18# if --tee was passed, write the output not only to the terminal, but
19# additionally to the file test-results/$BASENAME.out, too.
20case "$GIT_TEST_TEE_STARTED, $* " in
21done,*)
22 # do not redirect again
23 ;;
3da93652 24*' --tee '*|*' --va'*)
44138559
JS
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32esac
33
c2116a17
JH
34# Keep the original TERM for say_color
35ORIGINAL_TERM=$TERM
36
e1970ce4
JH
37# For repeatability, reset the environment to known value.
38LANG=C
899460f3 39LC_ALL=C
d9bdd39e 40PAGER=cat
e1970ce4 41TZ=UTC
c2116a17
JH
42TERM=dumb
43export LANG LC_ALL PAGER TERM TZ
8ff99e74 44EDITOR=:
d33738d7 45unset VISUAL
18508c39 46unset GIT_EDITOR
e1970ce4
JH
47unset AUTHOR_DATE
48unset AUTHOR_EMAIL
49unset AUTHOR_NAME
50unset COMMIT_AUTHOR_EMAIL
51unset COMMIT_AUTHOR_NAME
28a94f88 52unset EMAIL
e1970ce4
JH
53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54unset GIT_AUTHOR_DATE
29e55cd5
JH
55GIT_AUTHOR_EMAIL=author@example.com
56GIT_AUTHOR_NAME='A U Thor'
6677c466 57unset GIT_COMMITTER_DATE
29e55cd5
JH
58GIT_COMMITTER_EMAIL=committer@example.com
59GIT_COMMITTER_NAME='C O Mitter'
e1970ce4
JH
60unset GIT_DIFF_OPTS
61unset GIT_DIR
892c41b9 62unset GIT_WORK_TREE
e1970ce4
JH
63unset GIT_EXTERNAL_DIFF
64unset GIT_INDEX_FILE
65unset GIT_OBJECT_DIRECTORY
0454dd93 66unset GIT_CEILING_DIRECTORIES
e1970ce4
JH
67unset SHA1_FILE_DIRECTORIES
68unset SHA1_FILE_DIRECTORY
6ceeaee7 69unset GIT_NOTES_REF
894a9d33 70unset GIT_NOTES_DISPLAY_REF
6956f858
TR
71unset GIT_NOTES_REWRITE_REF
72unset GIT_NOTES_REWRITE_MODE
a1231de0
JK
73unset GIT_REFLOG_ACTION
74unset GIT_CHERRY_PICK_HELP
75unset GIT_QUIET
8d0fc48f
SP
76GIT_MERGE_VERBOSITY=5
77export GIT_MERGE_VERBOSITY
29e55cd5
JH
78export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
79export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 80export EDITOR
e1970ce4 81
886a3907
JH
82# Protect ourselves from common misconfiguration to export
83# CDPATH into the environment
84unset CDPATH
85
5565f47c
BW
86unset GREP_OPTIONS
87
3d5c0cc9 88case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
89 1|2|true)
90 echo "* warning: Some tests will not work if GIT_TRACE" \
91 "is set as to trace on STDERR ! *"
92 echo "* warning: Please set GIT_TRACE to something" \
93 "other than 1, 2 or true ! *"
94 ;;
95esac
96
cd3c095c
JH
97# Convenience
98#
99# A regexp to match 5 and 40 hexdigits
100_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
101_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
102
e1970ce4
JH
103# Each test should start with something like this, after copyright notices:
104#
105# test_description='Description of this test...
106# This test checks if command xyzzy does the right thing...
107# '
108# . ./test-lib.sh
c2116a17
JH
109[ "x$ORIGINAL_TERM" != "xdumb" ] && (
110 TERM=$ORIGINAL_TERM &&
111 export TERM &&
112 [ -t 1 ] &&
113 tput bold >/dev/null 2>&1 &&
114 tput setaf 1 >/dev/null 2>&1 &&
115 tput sgr0 >/dev/null 2>&1
116 ) &&
55db1df0 117 color=t
e1970ce4 118
e1970ce4
JH
119while test "$#" -ne 0
120do
121 case "$1" in
122 -d|--d|--de|--deb|--debu|--debug)
123 debug=t; shift ;;
886856ab
JH
124 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
125 immediate=t; shift ;;
5e2c08c6 126 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 127 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 128 -h|--h|--he|--hel|--help)
570f3226 129 help=t; shift ;;
e1970ce4
JH
130 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
131 verbose=t; shift ;;
1ece1274 132 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
133 # Ignore --quiet under a TAP::Harness. Saying how many tests
134 # passed without the ok/not ok details is always an error.
135 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
136 --with-dashes)
137 with_dashes=t; shift ;;
55db1df0 138 --no-color)
faa4bc35 139 color=; shift ;;
4e1be63c 140 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
3da93652 141 valgrind=t; verbose=t; shift ;;
44138559
JS
142 --tee)
143 shift ;; # was handled already
f423ef5f
JK
144 --root=*)
145 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
146 shift ;;
e1970ce4 147 *)
1f729dca 148 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
149 esac
150done
151
55db1df0
PH
152if test -n "$color"; then
153 say_color () {
c2116a17
JH
154 (
155 TERM=$ORIGINAL_TERM
156 export TERM
55db1df0
PH
157 case "$1" in
158 error) tput bold; tput setaf 1;; # bold red
159 skip) tput bold; tput setaf 2;; # bold green
160 pass) tput setaf 2;; # green
161 info) tput setaf 3;; # brown
1ece1274 162 *) test -n "$quiet" && return;;
55db1df0
PH
163 esac
164 shift
5099b99d 165 printf "%s" "$*"
55db1df0 166 tput sgr0
b8eecafd 167 echo
c2116a17 168 )
55db1df0
PH
169 }
170else
171 say_color() {
1ece1274 172 test -z "$1" && test -n "$quiet" && return
55db1df0 173 shift
5099b99d 174 echo "$*"
55db1df0
PH
175 }
176fi
177
178error () {
179 say_color error "error: $*"
6e7b5aaf 180 GIT_EXIT_OK=t
55db1df0
PH
181 exit 1
182}
183
184say () {
185 say_color info "$*"
186}
187
570f3226
MB
188test "${test_description}" != "" ||
189error "Test script did not set test_description."
190
191if test "$help" = "t"
192then
193 echo "$test_description"
194 exit 0
195fi
196
4d9d62fa 197exec 5>&1
e1970ce4
JH
198if test "$verbose" = "t"
199then
200 exec 4>&2 3>&1
201else
202 exec 4>/dev/null 3>/dev/null
203fi
204
205test_failure=0
206test_count=0
41ac414e
JH
207test_fixed=0
208test_broken=0
2d84e9fb 209test_success=0
e1970ce4 210
d998bd4a
ÆAB
211test_external_has_tap=0
212
faa4bc35 213die () {
6e7b5aaf
CB
214 code=$?
215 if test -n "$GIT_EXIT_OK"
216 then
217 exit $code
218 else
219 echo >&5 "FATAL: Unexpected exit with code $code"
220 exit 1
221 fi
faa4bc35
CB
222}
223
6e7b5aaf 224GIT_EXIT_OK=
35641310 225trap 'die' EXIT
41184273 226
02b35660
BD
227# The semantics of the editor variables are that of invoking
228# sh -c "$EDITOR \"$@\"" files ...
229#
230# If our trash directory contains shell metacharacters, they will be
231# interpreted if we just set $EDITOR directly, so do a little dance with
232# environment variables to work around this.
233#
234# In particular, quoting isn't enough, as the path may contain the same quote
7b7b4516 235# that we're using.
02b35660
BD
236test_set_editor () {
237 FAKE_EDITOR="$1"
238 export FAKE_EDITOR
d33738d7
JN
239 EDITOR='"$FAKE_EDITOR"'
240 export EDITOR
02b35660
BD
241}
242
68cfc6f5 243test_decode_color () {
a471833d
KB
244 awk '
245 function name(n) {
246 if (n == 0) return "RESET";
247 if (n == 1) return "BOLD";
248 if (n == 30) return "BLACK";
249 if (n == 31) return "RED";
250 if (n == 32) return "GREEN";
251 if (n == 33) return "YELLOW";
252 if (n == 34) return "BLUE";
253 if (n == 35) return "MAGENTA";
254 if (n == 36) return "CYAN";
255 if (n == 37) return "WHITE";
256 if (n == 40) return "BLACK";
257 if (n == 41) return "BRED";
258 if (n == 42) return "BGREEN";
259 if (n == 43) return "BYELLOW";
260 if (n == 44) return "BBLUE";
261 if (n == 45) return "BMAGENTA";
262 if (n == 46) return "BCYAN";
263 if (n == 47) return "BWHITE";
264 }
265 {
c2ed29b4 266 while (match($0, /\033\[[0-9;]*m/) != 0) {
a471833d
KB
267 printf "%s<", substr($0, 1, RSTART-1);
268 codes = substr($0, RSTART+2, RLENGTH-3);
269 if (length(codes) == 0)
270 printf "%s", name(0)
271 else {
272 n = split(codes, ary, ";");
273 sep = "";
274 for (i = 1; i <= n; i++) {
275 printf "%s%s", sep, name(ary[i]);
276 sep = ";"
277 }
278 }
279 printf ">";
280 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
281 }
282 print
283 }
284 '
68cfc6f5
MG
285}
286
9130ac9f
JK
287nul_to_q () {
288 perl -pe 'y/\000/Q/'
289}
290
c4f3f551
SB
291q_to_nul () {
292 perl -pe 'y/Q/\000/'
293}
294
295q_to_cr () {
296 tr Q '\015'
297}
298
800f1104
JN
299q_to_tab () {
300 tr Q '\011'
301}
302
c4f3f551
SB
303append_cr () {
304 sed -e 's/$/Q/' | tr Q '\015'
305}
306
307remove_cr () {
308 tr '\015' Q | sed -e 's/Q$//'
309}
310
00648ba0
EN
311# In some bourne shell implementations, the "unset" builtin returns
312# nonzero status when a variable to be unset was not set in the first
313# place.
314#
315# Use sane_unset when that should not be considered an error.
316
317sane_unset () {
318 unset "$@"
319 return 0
320}
321
04509738
JH
322test_tick () {
323 if test -z "${test_tick+set}"
324 then
21afc41c 325 test_tick=1112911993
04509738
JH
326 else
327 test_tick=$(($test_tick + 60))
328 fi
21afc41c
JH
329 GIT_COMMITTER_DATE="$test_tick -0700"
330 GIT_AUTHOR_DATE="$test_tick -0700"
04509738
JH
331 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
332}
e1970ce4 333
00884968
JS
334# Call test_commit with the arguments "<message> [<file> [<contents>]]"
335#
336# This will commit a file with the given contents and the given commit
337# message. It will also add a tag with <message> as name.
338#
339# Both <file> and <contents> default to <message>.
340
341test_commit () {
e656fc97 342 file=${2:-"$1.t"}
00884968
JS
343 echo "${3-$1}" > "$file" &&
344 git add "$file" &&
345 test_tick &&
346 git commit -m "$1" &&
347 git tag "$1"
348}
349
350# Call test_merge with the arguments "<message> <commit>", where <commit>
351# can be a tag pointing to the commit-to-merge.
352
353test_merge () {
354 test_tick &&
355 git merge -m "$1" "$2" &&
356 git tag "$1"
357}
358
1f553918
JS
359# This function helps systems where core.filemode=false is set.
360# Use it instead of plain 'chmod +x' to set or unset the executable bit
361# of a file in the working directory and add it to the index.
362
363test_chmod () {
364 chmod "$@" &&
365 git update-index --add "--chmod=$@"
366}
367
a7bb3940
JS
368# Use test_set_prereq to tell that a particular prerequisite is available.
369# The prerequisite can later be checked for in two ways:
370#
371# - Explicitly using test_have_prereq.
372#
373# - Implicitly by specifying the prerequisite tag in the calls to
374# test_expect_{success,failure,code}.
375#
376# The single parameter is the prerequisite tag (a simple word, in all
377# capital letters by convention).
378
379test_set_prereq () {
380 satisfied="$satisfied$1 "
381}
382satisfied=" "
383
384test_have_prereq () {
93a57246
ÆAB
385 # prerequisites can be concatenated with ','
386 save_IFS=$IFS
387 IFS=,
388 set -- $*
389 IFS=$save_IFS
ce60653e
ÆAB
390
391 total_prereq=0
392 ok_prereq=0
393 missing_prereq=
394
93a57246
ÆAB
395 for prerequisite
396 do
ce60653e 397 total_prereq=$(($total_prereq + 1))
93a57246
ÆAB
398 case $satisfied in
399 *" $prerequisite "*)
ce60653e
ÆAB
400 ok_prereq=$(($ok_prereq + 1))
401 ;;
93a57246 402 *)
ce60653e
ÆAB
403 # Keep a list of missing prerequisites
404 if test -z "$missing_prereq"
405 then
406 missing_prereq=$prerequisite
407 else
408 missing_prereq="$prerequisite,$missing_prereq"
409 fi
93a57246
ÆAB
410 esac
411 done
ce60653e
ÆAB
412
413 test $total_prereq = $ok_prereq
a7bb3940
JS
414}
415
05236a5e
JN
416test_declared_prereq () {
417 case ",$test_prereq," in
418 *,$1,*)
419 return 0
420 ;;
421 esac
422 return 1
423}
424
886856ab
JH
425# You are not expected to call test_ok_ and test_failure_ directly, use
426# the text_expect_* functions instead.
427
428test_ok_ () {
d5d9de1b 429 test_success=$(($test_success + 1))
5099b99d 430 say_color "" "ok $test_count - $@"
e1970ce4
JH
431}
432
886856ab 433test_failure_ () {
d5d9de1b 434 test_failure=$(($test_failure + 1))
5099b99d 435 say_color error "not ok - $test_count $1"
bf0dd8a8 436 shift
5099b99d 437 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 438 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
439}
440
41ac414e 441test_known_broken_ok_ () {
41ac414e 442 test_fixed=$(($test_fixed+1))
5099b99d 443 say_color "" "ok $test_count - $@ # TODO known breakage"
41ac414e
JH
444}
445
446test_known_broken_failure_ () {
41ac414e 447 test_broken=$(($test_broken+1))
5099b99d 448 say_color skip "not ok $test_count - $@ # TODO known breakage"
41ac414e 449}
886856ab
JH
450
451test_debug () {
8e832ebc 452 test "$debug" = "" || eval "$1"
e1970ce4
JH
453}
454
4d9d62fa 455test_run_ () {
b6b0afdc 456 test_cleanup=:
4d9d62fa 457 eval >&3 2>&4 "$1"
b6b0afdc 458 eval_ret=$?
3bf78867 459 eval >&3 2>&4 "$test_cleanup"
57e1538a
ÆAB
460 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
461 echo ""
462 fi
4d9d62fa
PR
463 return 0
464}
465
04ece593 466test_skip () {
8586f98b 467 test_count=$(($test_count+1))
04ece593
JH
468 to_skip=
469 for skp in $GIT_SKIP_TESTS
470 do
8586f98b 471 case $this_test.$test_count in
04ece593
JH
472 $skp)
473 to_skip=t
47e67d47 474 break
04ece593
JH
475 esac
476 done
05236a5e
JN
477 if test -z "$to_skip" && test -n "$test_prereq" &&
478 ! test_have_prereq "$test_prereq"
a7bb3940
JS
479 then
480 to_skip=t
481 fi
04ece593
JH
482 case "$to_skip" in
483 t)
07431fc8 484 of_prereq=
05236a5e 485 if test "$missing_prereq" != "$test_prereq"
07431fc8 486 then
05236a5e 487 of_prereq=" of $test_prereq"
07431fc8
JN
488 fi
489
55db1df0 490 say_color skip >&3 "skipping test: $@"
07431fc8 491 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
492 : true
493 ;;
494 *)
495 false
496 ;;
497 esac
498}
499
e1970ce4 500test_expect_failure () {
05236a5e 501 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
8e832ebc 502 test "$#" = 2 ||
a7bb3940 503 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
05236a5e 504 export test_prereq
04ece593 505 if ! test_skip "$@"
e1970ce4 506 then
41ac414e 507 say >&3 "checking known breakage: $2"
04ece593 508 test_run_ "$2"
41ac414e 509 if [ "$?" = 0 -a "$eval_ret" = 0 ]
04ece593 510 then
41ac414e 511 test_known_broken_ok_ "$1"
04ece593 512 else
6e7b5aaf 513 test_known_broken_failure_ "$1"
04ece593 514 fi
e1970ce4 515 fi
7a0cf2d0 516 echo >&3 ""
e1970ce4
JH
517}
518
519test_expect_success () {
05236a5e 520 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
8e832ebc 521 test "$#" = 2 ||
a7bb3940 522 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
05236a5e 523 export test_prereq
04ece593 524 if ! test_skip "$@"
e1970ce4 525 then
04ece593
JH
526 say >&3 "expecting success: $2"
527 test_run_ "$2"
528 if [ "$?" = 0 -a "$eval_ret" = 0 ]
529 then
530 test_ok_ "$1"
531 else
532 test_failure_ "$@"
533 fi
e1970ce4 534 fi
7a0cf2d0 535 echo >&3 ""
e1970ce4
JH
536}
537
fb32c410
LW
538# test_external runs external test scripts that provide continuous
539# test output about their progress, and succeeds/fails on
540# zero/non-zero exit code. It outputs the test output on stdout even
d998bd4a 541# in non-verbose mode, and announces the external script with "# run
fb32c410
LW
542# <n>: ..." before running it. When providing relative paths, keep in
543# mind that all scripts run in "trash directory".
544# Usage: test_external description command arguments...
545# Example: test_external 'Perl API' perl ../path/to/test.pl
546test_external () {
05236a5e 547 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
a7bb3940
JS
548 test "$#" = 3 ||
549 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
fb32c410
LW
550 descr="$1"
551 shift
05236a5e 552 export test_prereq
fb32c410
LW
553 if ! test_skip "$descr" "$@"
554 then
555 # Announce the script to reduce confusion about the
556 # test output that follows.
d998bd4a 557 say_color "" "# run $test_count: $descr ($*)"
5ae8030f
JN
558 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
559 # to be able to use them in script
560 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
fb32c410
LW
561 # Run command; redirect its stderr to &4 as in
562 # test_run_, but keep its stdout on our stdout even in
563 # non-verbose mode.
564 "$@" 2>&4
565 if [ "$?" = 0 ]
566 then
d998bd4a
ÆAB
567 if test $test_external_has_tap -eq 0; then
568 test_ok_ "$descr"
569 else
570 say_color "" "# test_external test $descr was ok"
571 test_success=$(($test_success + 1))
572 fi
fb32c410 573 else
d998bd4a
ÆAB
574 if test $test_external_has_tap -eq 0; then
575 test_failure_ "$descr" "$@"
576 else
577 say_color error "# test_external test $descr failed: $@"
578 test_failure=$(($test_failure + 1))
579 fi
fb32c410
LW
580 fi
581 fi
582}
583
584# Like test_external, but in addition tests that the command generated
585# no output on stderr.
586test_external_without_stderr () {
587 # The temporary file has no (and must have no) security
588 # implications.
589 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
590 stderr="$tmp/git-external-stderr.$$.tmp"
591 test_external "$@" 4> "$stderr"
592 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
593 descr="no stderr: $1"
594 shift
d998bd4a 595 say >&3 "# expecting no stderr from previous command"
fb32c410
LW
596 if [ ! -s "$stderr" ]; then
597 rm "$stderr"
d998bd4a
ÆAB
598
599 if test $test_external_has_tap -eq 0; then
600 test_ok_ "$descr"
601 else
602 say_color "" "# test_external_without_stderr test $descr was ok"
603 test_success=$(($test_success + 1))
604 fi
fb32c410
LW
605 else
606 if [ "$verbose" = t ]; then
d998bd4a 607 output=`echo; echo "# Stderr is:"; cat "$stderr"`
fb32c410
LW
608 else
609 output=
610 fi
611 # rm first in case test_failure exits.
612 rm "$stderr"
d998bd4a
ÆAB
613 if test $test_external_has_tap -eq 0; then
614 test_failure_ "$descr" "$@" "$output"
615 else
616 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
617 test_failure=$(($test_failure + 1))
618 fi
fb32c410
LW
619 fi
620}
621
2caf20c5
MM
622# debugging-friendly alternatives to "test [-f|-d|-e]"
623# The commands test the existence or non-existence of $1. $2 can be
624# given to provide a more precise diagnosis.
625test_path_is_file () {
626 if ! [ -f "$1" ]
627 then
628 echo "File $1 doesn't exist. $*"
629 false
630 fi
631}
632
633test_path_is_dir () {
634 if ! [ -d "$1" ]
635 then
636 echo "Directory $1 doesn't exist. $*"
637 false
638 fi
639}
640
641test_path_is_missing () {
642 if [ -e "$1" ]
643 then
644 echo "Path exists:"
645 ls -ld "$1"
646 if [ $# -ge 1 ]; then
647 echo "$*"
648 fi
649 false
650 fi
651}
652
fb3340a6
JN
653# test_line_count checks that a file has the number of lines it
654# ought to. For example:
655#
656# test_expect_success 'produce exactly one line of output' '
657# do something >output &&
658# test_line_count = 1 output
659# '
660#
661# is like "test $(wc -l <output) = 1" except that it passes the
662# output through when the number of lines is wrong.
663
664test_line_count () {
665 if test $# != 3
666 then
667 error "bug in the test script: not 3 parameters to test_line_count"
668 elif ! test $(wc -l <"$3") "$1" "$2"
669 then
670 echo "test_line_count: line count for $3 !$1 $2"
671 cat "$3"
672 return 1
673 fi
674}
2caf20c5 675
74359821
JH
676# This is not among top-level (test_expect_success | test_expect_failure)
677# but is a prefix that can be used in the test script, like:
678#
679# test_expect_success 'complain and die' '
680# do something &&
681# do something else &&
682# test_must_fail git checkout ../outerspace
683# '
684#
685# Writing this as "! git checkout ../outerspace" is wrong, because
686# the failure could be due to a segv. We want a controlled failure.
687
688test_must_fail () {
689 "$@"
16034fbe
JK
690 exit_code=$?
691 if test $exit_code = 0; then
692 echo >&2 "test_must_fail: command succeeded: $*"
693 return 1
694 elif test $exit_code -gt 129 -a $exit_code -le 192; then
695 echo >&2 "test_must_fail: died by signal: $*"
696 return 1
a54ce3ca
JK
697 elif test $exit_code = 127; then
698 echo >&2 "test_must_fail: command not found: $*"
699 return 1
16034fbe
JK
700 fi
701 return 0
74359821
JH
702}
703
fdf1bc48
JN
704# Similar to test_must_fail, but tolerates success, too. This is
705# meant to be used in contexts like:
706#
707# test_expect_success 'some command works without configuration' '
708# test_might_fail git config --unset all.configuration &&
709# do something
710# '
711#
712# Writing "git config --unset all.configuration || :" would be wrong,
713# because we want to notice if it fails due to segv.
714
715test_might_fail () {
716 "$@"
5c8e1414
JN
717 exit_code=$?
718 if test $exit_code -gt 129 -a $exit_code -le 192; then
719 echo >&2 "test_might_fail: died by signal: $*"
720 return 1
d0b8a617
JN
721 elif test $exit_code = 127; then
722 echo >&2 "test_might_fail: command not found: $*"
723 return 1
5c8e1414
JN
724 fi
725 return 0
fdf1bc48
JN
726}
727
892e6f7e
ÆAB
728# Similar to test_must_fail and test_might_fail, but check that a
729# given command exited with a given exit code. Meant to be used as:
730#
731# test_expect_success 'Merge with d/f conflicts' '
732# test_expect_code 1 git merge "merge msg" B master
733# '
734
735test_expect_code () {
736 want_code=$1
737 shift
738 "$@"
739 exit_code=$?
740 if test $exit_code = $want_code
741 then
742 echo >&2 "test_expect_code: command exited with $exit_code: $*"
743 return 0
744 else
745 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
746 return 1
747 fi
748}
749
82ebb0b6
JK
750# test_cmp is a helper function to compare actual and expected output.
751# You can use it like:
752#
753# test_expect_success 'foo works' '
754# echo expected >expected &&
755# foo >actual &&
756# test_cmp expected actual
757# '
758#
759# This could be written as either "cmp" or "diff -u", but:
760# - cmp's output is not nearly as easy to read as diff -u
761# - not all diff versions understand "-u"
762
763test_cmp() {
764 $GIT_TEST_CMP "$@"
765}
766
3bf78867
JN
767# This function can be used to schedule some commands to be run
768# unconditionally at the end of the test to restore sanity:
769#
770# test_expect_success 'test core.capslock' '
771# git config core.capslock true &&
772# test_when_finished "git config --unset core.capslock" &&
773# hello world
774# '
775#
776# That would be roughly equivalent to
777#
778# test_expect_success 'test core.capslock' '
779# git config core.capslock true &&
780# hello world
781# git config --unset core.capslock
782# '
783#
784# except that the greeting and config --unset must both succeed for
785# the test to pass.
786
787test_when_finished () {
b6b0afdc
JN
788 test_cleanup="{ $*
789 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
3bf78867
JN
790}
791
0509eb21 792# Most tests can use the created repository, but some may need to create more.
eedf8f97
CW
793# Usage: test_create_repo <directory>
794test_create_repo () {
795 test "$#" = 1 ||
796 error "bug in the test script: not 1 parameter to test-create-repo"
eedf8f97 797 repo="$1"
bfdbee98 798 mkdir -p "$repo"
0d314ce8
ÆAB
799 (
800 cd "$repo" || error "Cannot setup test environment"
801 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
802 error "cannot run git init -- have you built things yet?"
803 mv .git/hooks .git/hooks-disabled
804 ) || exit
eedf8f97 805}
a6080a0a 806
e1970ce4 807test_done () {
6e7b5aaf 808 GIT_EXIT_OK=t
2d84e9fb 809
8ef1abe5
ÆAB
810 if test -z "$HARNESS_ACTIVE"; then
811 test_results_dir="$TEST_DIRECTORY/test-results"
812 mkdir -p "$test_results_dir"
813 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
814
815 echo "total $test_count" >> $test_results_path
816 echo "success $test_success" >> $test_results_path
817 echo "fixed $test_fixed" >> $test_results_path
818 echo "broken $test_broken" >> $test_results_path
819 echo "failed $test_failure" >> $test_results_path
820 echo "" >> $test_results_path
821 fi
41ac414e
JH
822
823 if test "$test_fixed" != 0
824 then
5099b99d 825 say_color pass "# fixed $test_fixed known breakage(s)"
41ac414e
JH
826 fi
827 if test "$test_broken" != 0
828 then
5099b99d 829 say_color error "# still have $test_broken known breakage(s)"
11d54b8b
JH
830 msg="remaining $(($test_count-$test_broken)) test(s)"
831 else
832 msg="$test_count test(s)"
41ac414e 833 fi
e1970ce4 834 case "$test_failure" in
10b94e28 835 0)
5099b99d
ÆAB
836 # Maybe print SKIP message
837 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
838
d998bd4a
ÆAB
839 if test $test_external_has_tap -eq 0; then
840 say_color pass "# passed all $msg"
841 say "1..$test_count$skip_all"
842 fi
abc5d372
JS
843
844 test -d "$remove_trash" &&
845 cd "$(dirname "$remove_trash")" &&
846 rm -rf "$(basename "$remove_trash")"
847
e1970ce4
JH
848 exit 0 ;;
849
850 *)
d998bd4a
ÆAB
851 if test $test_external_has_tap -eq 0; then
852 say_color error "# failed $test_failure among $msg"
853 say "1..$test_count"
854 fi
5099b99d 855
e1970ce4
JH
856 exit 1 ;;
857
858 esac
859}
860
861# Test the binaries we have just built. The tests are kept in
9adefee5 862# t/ subdirectory and are run in 'trash directory' subdirectory.
62f53904
ÆAB
863if test -z "$TEST_DIRECTORY"
864then
865 # We allow tests to override this, in case they want to run tests
866 # outside of t/, e.g. for running tests on the test library
867 # itself.
868 TEST_DIRECTORY=$(pwd)
869fi
6cec5c68
ÆAB
870GIT_BUILD_DIR="$TEST_DIRECTORY"/..
871
e4597aae 872if test -n "$valgrind"
4e1be63c 873then
4e1be63c
JS
874 make_symlink () {
875 test -h "$2" &&
876 test "$1" = "$(readlink "$2")" || {
877 # be super paranoid
878 if mkdir "$2".lock
879 then
880 rm -f "$2" &&
881 ln -s "$1" "$2" &&
882 rm -r "$2".lock
883 else
884 while test -d "$2".lock
885 do
886 say "Waiting for lock on $2."
887 sleep 1
888 done
889 fi
890 }
891 }
892
893 make_valgrind_symlink () {
894 # handle only executables
895 test -x "$1" || return
896
897 base=$(basename "$1")
6cec5c68 898 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
899 # do not override scripts
900 if test -x "$symlink_target" &&
901 test ! -d "$symlink_target" &&
902 test "#!" != "$(head -c 2 < "$symlink_target")"
903 then
904 symlink_target=../valgrind.sh
905 fi
efd92ffd
JS
906 case "$base" in
907 *.sh|*.perl)
908 symlink_target=../unprocessed-script
909 esac
4e1be63c
JS
910 # create the link, or replace it if it is out of date
911 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
912 }
913
914 # override all git executables in TEST_DIRECTORY/..
915 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
916 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 917 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
918 do
919 make_valgrind_symlink $file
920 done
efd92ffd
JS
921 OLDIFS=$IFS
922 IFS=:
923 for path in $PATH
924 do
925 ls "$path"/git-* 2> /dev/null |
926 while read file
927 do
928 make_valgrind_symlink "$file"
929 done
930 done
931 IFS=$OLDIFS
4e1be63c
JS
932 PATH=$GIT_VALGRIND/bin:$PATH
933 GIT_EXEC_PATH=$GIT_VALGRIND/bin
934 export GIT_VALGRIND
e4597aae
MO
935elif test -n "$GIT_TEST_INSTALLED" ; then
936 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
937 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 938 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
939 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
940else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 941 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
e4597aae
MO
942 if ! test -x "$git_bin_dir/git" ; then
943 if test -z "$with_dashes" ; then
944 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
945 fi
946 with_dashes=t
947 fi
948 PATH="$git_bin_dir:$PATH"
6cec5c68 949 GIT_EXEC_PATH=$GIT_BUILD_DIR
e4597aae 950 if test -n "$with_dashes" ; then
6cec5c68 951 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 952 fi
4e1be63c 953fi
6cec5c68 954GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 955unset GIT_CONFIG
8bfa6bd6
JK
956GIT_CONFIG_NOSYSTEM=1
957GIT_CONFIG_NOGLOBAL=1
958export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
49ccb087 959
aed604c7 960. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
ac10a857 961
5e87eae9
JH
962if test -z "$GIT_TEST_CMP"
963then
964 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
965 then
966 GIT_TEST_CMP="$DIFF -c"
967 else
968 GIT_TEST_CMP="$DIFF -u"
969 fi
970fi
971
6cec5c68 972GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 973export GITPERLLIB
6cec5c68 974test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
975 error "You haven't built things yet, have you?"
976}
e1970ce4 977
ac10a857 978if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 979then
6cec5c68 980 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 981 export GITPYTHONLIB
6cec5c68 982 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
983 error "You haven't built git_remote_helpers yet, have you?"
984 }
985fi
986
6cec5c68 987if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
56cf9806
EW
988 echo >&2 'You need to build test-chmtime:'
989 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
990 exit 1
991fi
992
e1970ce4 993# Test repository
abc5d372 994test="trash directory.$(basename "$0" .sh)"
f423ef5f
JK
995test -n "$root" && test="$root/$test"
996case "$test" in
997/*) TRASH_DIRECTORY="$test" ;;
998 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
999esac
91c8b825 1000test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
8d14ac94 1001rm -fr "$test" || {
6e7b5aaf 1002 GIT_EXIT_OK=t
8d14ac94
JH
1003 echo >&5 "FATAL: Cannot prepare test area"
1004 exit 1
1005}
1006
90cff968
AR
1007HOME="$TRASH_DIRECTORY"
1008export HOME
1009
4a7aaccd 1010test_create_repo "$test"
1bd9c648
LW
1011# Use -P to resolve symlinks in our working directory so that the cwd
1012# in subprocesses like git equals our $PWD (for pathname comparisons).
1013cd -P "$test" || exit 1
04ece593 1014
d5d9de1b
JS
1015this_test=${0##*/}
1016this_test=${this_test%%-*}
04ece593
JH
1017for skp in $GIT_SKIP_TESTS
1018do
47e67d47
MG
1019 case "$this_test" in
1020 $skp)
55db1df0 1021 say_color skip >&3 "skipping test $this_test altogether"
637ab29b 1022 skip_all="skip all tests in $this_test"
04ece593
JH
1023 test_done
1024 esac
1025done
f17e9fbb 1026
8648732e
BC
1027# Provide an implementation of the 'yes' utility
1028yes () {
1029 if test $# = 0
1030 then
1031 y=y
1032 else
1033 y="$*"
1034 fi
1035
1036 while echo "$y"
1037 do
1038 :
1039 done
1040}
1041
f17e9fbb
JS
1042# Fix some commands on Windows
1043case $(uname -s) in
1044*MINGW*)
1045 # Windows has its own (incompatible) sort and find
1046 sort () {
1047 /usr/bin/sort "$@"
1048 }
1049 find () {
1050 /usr/bin/find "$@"
1051 }
5397ea31
JS
1052 sum () {
1053 md5sum "$@"
1054 }
4114156a
JS
1055 # git sees Windows-style pwd
1056 pwd () {
1057 builtin pwd -W
1058 }
ee9fb68c 1059 # no POSIX permissions
6fd1106a 1060 # backslashes in pathspec are converted to '/'
fb9a2bea 1061 # exec does not inherit the PID
a94114ad 1062 test_set_prereq MINGW
a31d0665
RJ
1063 test_set_prereq SED_STRIPS_CR
1064 ;;
1065*CYGWIN*)
1066 test_set_prereq POSIXPERM
a31d0665
RJ
1067 test_set_prereq EXECKEEPSPID
1068 test_set_prereq NOT_MINGW
1069 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
1070 ;;
1071*)
1072 test_set_prereq POSIXPERM
6fd1106a 1073 test_set_prereq BSLASHPSPEC
fb9a2bea 1074 test_set_prereq EXECKEEPSPID
3ba9ba8f 1075 test_set_prereq NOT_MINGW
f17e9fbb
JS
1076 ;;
1077esac
704a3143 1078
1b19ccd2 1079test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 1080test -z "$NO_PYTHON" && test_set_prereq PYTHON
1b19ccd2 1081
704a3143
JS
1082# test whether the filesystem supports symbolic links
1083ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1084rm -f y
c91cfd19
ÆAB
1085
1086# When the tests are run as root, permission tests will report that
1087# things are writable when they shouldn't be.
1088test -w / || test_set_prereq SANITY